<?php

class CompleteSet {

    private $dbc = null;

    public static $list_of_sets = [
        '1TFC',
        '2ROF',
        '3INK',
        '4URS',
        '5SSK',
        '6AZS',
    ];

    function __construct($dbc) {
    
        $this->dbc = $dbc;

    }

    function find_cards() {

        $values_sanitised = CompleteSet::sanitise_input();

        $sql = "SELECT DISTINCT s.*, s.name as set_name, c.*, lm.*, i.*
                FROM card c 
                    INNER JOIN `lorcana_meta` lm ON lm.card_id = c.id
                    INNER JOIN `set` s ON c.set_id = s.id
                    LEFT JOIN `inventory` i ON i.card_id = c.id
                WHERE `number` IN ('".implode("','", $values_sanitised['numbers'])."') AND s.token='".$values_sanitised['set']."'
                LIMIT 206";

        //echo $sql . '<br/>';

        $cards_data = $this->dbc->query($sql);

        $found_cards = [];
        $estimated_cost = 0;
        $cards_available = 0;
        $cards_unavailable = 0;

        foreach($cards_data as $card) {
            $found_cards[] = $card;
            if (isset($card['price'])) {
                $cards_available ++;
                $estimated_cost += $card['price'];
            } else {
                $cards_unavailable++;
                $estimated_cost += $card['market_price'];
            }
        }

        //debug($found_cards);

        $still_missing = ['4b'];

        return [
            'cards_requested' => count($found_cards) + count($still_missing),  
            'cards_found' => count($found_cards),
            'cards_available' => $cards_available,
            'cards_unavailable' => $cards_unavailable,
            'cards_missing' => count($still_missing),
            'still_missing' => $still_missing,
            'found_cards' => $found_cards,
            'estimated_cost' => $estimated_cost,
        ];

    }

    private static function sanitise_input() {

        // debug($_POST, false);

        $clean_list = preg_replace("/[^A-Za-z0-9\,]/", '', $_POST['missing_cards']);

        $selected_set = '6AZS';
        
        foreach(CompleteSet::$list_of_sets as $set) {
            if ($_POST['set'] == $set) {
                $selected_set = $set;
            }
        }

        // debug($clean_list, false);

        $list_of_numbers = explode(',', $clean_list);

        // debug($list_of_numbers, false);

        return [
            'set' => $selected_set,
            'numbers' => $list_of_numbers,
        ];

    }


}