<?php

class Inventory {

    private $dbc = null;

    private $user_id = null;

    function __construct($dbc, $user_id=1) {
    
        $this->dbc = $dbc;
        $this->user_id = $user_id;

    }

    function get_cards () {

        $cards = [];

        $sql = "SELECT i.*, c.name, c.version, lm.image_small as image, mp.*
                FROM inventory i 
                    INNER JOIN card c ON c.id = i.card_id
                    INNER JOIN lorcana_meta lm ON lm.card_id = i.card_id
                    INNER JOIN market_price mp ON mp.cardmarket_id=c.cardmarket_id
                WHERE user_id = ".$this->user_id." 
                ORDER BY i.id ASC";
        
        $results = $this->dbc->select($sql);

        foreach($results as $result) {

            //debug($result);

            $result['name'] = html_entity_decode($result['name']);
            $result['version'] = html_entity_decode($result['version']);

            $cards[] = $result; 
        }

        return $cards;
    }

    function update ($post_data) {

        //debug($_POST, false);

        foreach($_POST['card-id'] as $card_id) {

            if ($_POST[$card_id.'-updated'] == 0) {
                continue;
            }

            $update = [
                'quality' => $this->dbc->sanitise($_POST[$card_id.'-quality']),
                'type' => $this->dbc->sanitise($_POST[$card_id.'-type']),
                'quantity' => $this->dbc->sanitise($_POST[$card_id.'-quantity']),
                'price' => $this->dbc->sanitise($_POST[$card_id.'-price']),
            ];

            $sql = "UPDATE inventory SET quality=".$update['quality'].",type=".$update['type'].",quantity=".$update['quantity'].",price=".$update['price']." WHERE id=".$card_id."";
            //echo $sql . '<br/>';
            $this->dbc->query($sql);

        }

    }

    function get_statistics() {

        $sql = "SELECT c.rarity, count(*) as total
                FROM card c 
                    INNER JOIN inventory i ON i.card_id=c.id 
                WHERE i.quantity > 0
                GROUP BY c.rarity;";

        $results = $this->dbc->select($sql);

        $total = 0;
        $card_totals = [];

        foreach($results as $data) {
            $rarity = str_replace('-','', strtolower($data['rarity']));
            $card_totals[$rarity] = $data['total'];
            $total += $data['total'];
        }

        $card_totals['total'] = $total;

        return $card_totals;

    }

}