<?php

// $lorcana_data = new LorcanaData();
// $raw_card_list = $lorcana_data->import_card_list();
// $json_card_list = $lorcana_data->load_card_json();
// $lorcana_data->save_json_data();


class LorcanaData {

    public $card_list_raw = [];
    public $card_list_json = [];

    function import_card_list() {

        $csv_path = CACHE_DIR . '/lorcana-collection.csv';

        $this->card_list_raw = [];

        $row = 1;
        if (($handle = fopen($csv_path, "r")) !== FALSE) {
            while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
                if($row == 1) {
                    $row++; continue;
                }
                $this->card_list_raw[] = [
                    'name' => $data[2],
                    'count' => [
                        'normal' => $data[0],
                        'foil' => $data[1],
                    ],
                    'set' => (int)$data[3],
                    'number' => (int)$data[4],
                ];
            }
            fclose($handle);
        }

        return $this->card_list_raw;

    }

    function load_card_json() {

        $this->card_list_json = [];

        for($i=0; $i<count($this->card_list_raw); $i++) {

            $card_data = $this->card_list_raw[$i];

            //debug($card_data);

            $tmp_card_data = $this->_fetch_data($card_data['set'], $card_data['number']);

            $tmp_card_data['custom'] = $card_data['count'];

            $this->card_list_json[] = $tmp_card_data;

            usleep(100000);

        }

        return $this->card_list_json;

    }

    function load_json_data() {

        return json_decode(file_get_contents(CACHE_DIR . '/lorcana-collection.json'), true);

    }

    function save_json_data() {

        file_put_contents(CACHE_DIR . '/lorcana-collection.json', json_encode($this->card_list_json));

    }

    function _fetch_data($set, $number) {

        $ch = curl_init("https://api.lorcast.com/v0/cards/".$set."/".$number);
        
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $output = curl_exec($ch);

        if(curl_error($ch)) {
            die('Jon you idiot, you messed up...');
        }
        
        curl_close($ch);

        return json_decode($output, true);

    }





}