<?php

class Component {

	private $_js = [];
	private $_css = [];
  private $_content = [];

  private $_template = null;
  private $_database = null;

  private $template_name = '';
  private $controller_name = '';

  public function __construct($dbc=null) {

		$twig = new Twig_Environment(new Twig_Loader_Filesystem([
			TEMPLATE_DIR,
			//TEMPLATE_DIR . '/content/tech'
		]));
		
		$twig->addExtension(new Twig_Extension_Debug());

		$this->_template = $twig;

		$this->_database = $dbc;

  }

  public function __destruct() {

      unset($this->_template);
      unset($this->_database);

  }

  public function js($js) {

    $this->_js[] = $js;

  }

  public function css($css) {

    $this->_css[] = $css;

  }

  public function content($content) {

    $this->_content = array_merge($this->_content, $content);

  }

  public function dbc() {

    return $this->_database;

  }

  public function getController() {

    return $this->controller_name;

  }

  public function setController($controller) {

    $this->controller_name = $controller;

  }

  public function setTemplate($template) {

    $this->template_name = $template;

  }

  public function render() {

    $content = [
			'js' => $this->_js,
			'css' => $this->_css,
		];

    $content = array_merge($content, $this->_content);

    return $this->_template->render($this->template_name, $content);
  }

}
