<?php

$selected_postage_option = null;
foreach(ShoppingCart::postage_options() as $postage_option) {
    if ($postage_option['key'] == $_POST['postage']) {
        $selected_postage_option = $postage_option;
    }
}

// echo 'Selected Postage Option: <xmp>'; print_r($selected_postage_option); echo '</xmp><br/>'; 

$shopping_cart = new ShoppingCart($dbc);
$cart_data = $shopping_cart->get_cart_contents();
$totals_data = $shopping_cart->calculate_totals($cart_data);

// debug($cart_data);
// debug($totals_data, false);

$total_price = $totals_data['total_price'] + $selected_postage_option['price'];

//echo '<pre>';

$apiContext = new \PayPal\Rest\ApiContext(
    new \PayPal\Auth\OAuthTokenCredential(
        PAYPAL_CLIENTID,        // ClientID
        PAYPAL_CLIENTSECRET    // ClientSecret
    )
);

$apiContext->setConfig(['mode' => PAYPAL_MODE]);

$payer = new \PayPal\Api\Payer();
$payer->setPaymentMethod('paypal');

$amount = new \PayPal\Api\Amount();
$amount->setTotal($total_price);
$amount->setCurrency('GBP');

$transaction = new \PayPal\Api\Transaction();
$transaction->setAmount($amount);
$transaction->setDescription($totals_data['total_cards'] . 'x trading card(s)');

$redirectUrls = new \PayPal\Api\RedirectUrls();
$redirectUrls->setReturnUrl("http://".APP_DOMAIN."/cart/checkout/handle")
    ->setCancelUrl("http://".APP_DOMAIN."/cart/checkout/cancel");

$payment = new \PayPal\Api\Payment();
$payment->setIntent('sale')
    ->setPayer($payer)
    ->setTransactions(array($transaction))
    ->setRedirectUrls($redirectUrls);

try {
    
    $payment->create($apiContext);
    
    $transaction = [
        'token' => $payment->getId(),
        'timestamp' => time(),
        'session_id' => $_SESSION['id'],
        'item_price' => $totals_data['total_price'],
        'postage_type' => $selected_postage_option['key'],
        'postage_price' => $selected_postage_option['price'],
        'discount' => 0,
        'total_price' => $total_price,
        'items_purchased' => [],
    ];
    
    foreach($cart_data as $item) {
        $transaction['items_purchased'][] = [
            'id' => $item['card_data']['id'],
            'quantity' => $item['cart_data']['quantity'],
            'printing' => $item['cart_data']['printing'],
            'price' => $item['card_data']['price'],
        ];
    }
    
    // debug($cart_data, false);
    // debug($transaction);
    // debug($_SESSION, false);
    
    
    $sql = "INSERT INTO transaction (timestamp, payment_id, session_id, data) VALUES (".time().",'".$payment->getId()."','".$_SESSION['id']."','".json_encode($transaction)."');";
    //echo $sql . '<br/>';
    $dbc->query($sql);
    //exit;

    //echo "\n\nRedirect user to approval_url: " . $payment->getApprovalLink() . "\n";
    header('location: '.$payment->getApprovalLink());
    exit;
}
catch (\PayPal\Exception\PayPalConnectionException $ex) {
    // This will print the detailed information on the exception.
    //REALLY HELPFUL FOR DEBUGGING
    echo $ex->getData();
    exit;
}
