<?php

use PayPal\Api\Payment;
use PayPal\Rest\ApiContext;

include_once CLASS_DIR . 'class.Order.php';

$apiContext = new ApiContext(
    new \PayPal\Auth\OAuthTokenCredential(
        PAYPAL_CLIENTID,        // ClientID
        PAYPAL_CLIENTSECRET    // ClientSecret
    )
);

$apiContext->setConfig(['mode' => PAYPAL_MODE]);

$sql = "SELECT * FROM `transaction` WHERE md5(payment_id)='".$_GET['id']."' LIMIT 1;";
//echo $sql . '<br/>';
$transaction_record = $dbc->select($sql, true);

$transaction_record['data'] = json_decode($transaction_record['data'], false);

//debug($transaction_record, false);

$payment = Payment::get($transaction_record['payment_id'], $apiContext);

//debug($payment);

$shipping_address = $payment->getPayer()->getPayerInfo()->getShippingAddress();

//debug($shipping_address, false);

$order = new Order($dbc);

$items_in_order = $order->items_in_order($transaction_record['data']);

$page->content([
    'items_in_order' => $items_in_order,
    'recipient_name' => $shipping_address->getRecipientName(),
    'address_line1' => $shipping_address->getLine1(),
    'address_line2' => $shipping_address->getLine2(),
    'address_city' => $shipping_address->getCity(),
    'address_state' => $shipping_address->getState(),
    'address_postcode' => $shipping_address->getPostalCode(),
]);

$page->css('order.css');